/*
 * Knight.cpp
 *
 *  Created on: 15/apr/2013
 *      Author: bertini
 */

#include <iostream>
#include "Knight.h"

Knight::Knight(std::string aName, int hp, int l, int d, int a, int x, int y) :
		Character(hp, l, a, x, y), dexterity(d) {
	name = aName;
	std::cout << "Knight -  constructor" << std::endl;

}

Knight::~Knight() {
	std::cout << "Delete Knight from game map" << std::endl;
}

int Knight::fight(Character& enemy) {
	Dice aDice(4);
	int hit = aDice.throwDice() * dexterity;
	int allDamage = 0;
	int attacks = 1;
	if (level > 6)
		attacks++;

	while (attacks > 0) {
		std::cout << "Attack #" << attacks << std::endl;
		if (hit > enemy.getLevel()) {
			if (!weapon)
				return 1; // bare hand fight: mimimum damage
			int damage = 0;
			damage = weapon->useWeapon();
			if (damage > enemy.getArmor()) {
				enemy.setHp( enemy.getHp() - damage);
				std::cout << "enemy hit: " << damage << std::endl;
				allDamage += damage;
			} else {
				std::cout << "did not pass through enemy armor !" << std::endl;
			}
		} else
			std::cout << "hit miss !" << std::endl;
		attacks--;
	}

	return allDamage;
}

void Knight::move(int x, int y) {
	posX = x;
	posY = y;
	std::cout << "Knight moving to: " << x << " - " << y << std::endl;
}
